LeetCode 259. 3Sum Smaller

题目

Given an array of n integers nums and a target, find the number of index triplets i, j, k with 0 <= i < j < k < n that satisfy the condition nums[i] + nums[j] + nums[k] < target.

Example:

Input: nums = [-2,0,1,3], and target = 2
Output: 2 
Explanation: Because there are two triplets which sums are less than 2:
             [-2,0,1]
             [-2,0,3]

Follow up: Could you solve it in O(n2) runtime?


这道题是要求一个数组中任意三个数字相加之和小于target的个数。我差一点点就做出来了,哎。就还是3sum的套路,固定外层,里面用双指针解决。在双指针判断的大小的过程中需要有一点变化,那就是如果sum < target的话,因为是按升序排序的,所以相当于再固定start的话后面加任意从start+1开始一直到end的数字都是满足条件的,于是result就可以直接+= (end - start),同时也需要再把start往后挪一个,其实跟3sum就是一样的了,但是刚开始想岔了以为可以直接break掉orz……其他情况下就直接往前挪end就好。时间复杂度O(n^2),空间O(1)。

Runtime: 6 ms, faster than 42.67% of Java online submissions for 3Sum Smaller.

Memory Usage: 38.5 MB, less than 47.06% of Java online submissions for 3Sum Smaller.

class Solution {
    public int threeSumSmaller(int[] nums, int target) {
        int result = 0;
        Arrays.sort(nums);
        
        for (int i = 0; i < nums.length - 2; i++) {
            int pStart = i + 1;
            int pEnd = nums.length - 1;
            
            while (pStart < pEnd) {
                int sum = nums[i] + nums[pStart] + nums[pEnd];
                if (sum < target) {
                    result += (pEnd - pStart);
                    pStart++;
                } else {
                    pEnd--;
                }
            }
        }
        
        return result;
    }
}

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值